package mdd.client;

import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.geometry.Bounds;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.ScrollPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class Optimizer extends Stage implements IGUIEventClient {
private HBox generations = new HBox();
protected GUIEventHandler _eventHandler;

    public Optimizer(){
        super();
        _eventHandler = GUIEventHandler.getEventHandler();
        _eventHandler.addEventListener(this, 5);
        generations.setSpacing(30);
        setTitle("Optimizer");
        Scene scene = new Scene(new ScrollPane(generations), 450, 450);
        scene.getStylesheets().add(String.valueOf(getClass().getResource("dark-theme.css")));
        setScene(scene);
    }

    @Override
    public void processGUIEvent(String event, JSONObject args) {
        if (event.equals("change")){
            if (!args.containsKey("args")){
                return;
            }
            JSONObject jargs = (JSONObject) args.get("args");
            if (!jargs.containsKey("subject")){
                return;
            }
            JSONObject jsub = (JSONObject) jargs.get("subject");
            if (!jsub.get("type").equals("optimizer")){
                return;
            }
            if (!args.containsKey("operation")){
                return;
            }
            JSONObject jobj = (JSONObject) jargs.get("object");
            switch((String) args.get("operation")){
                case "add":
                    if (jobj.containsKey("individuals")){
                        JSONArray indis= (JSONArray)jobj.get("individuals");
                        if (generations.getChildren().size() == (int)jobj.get("generation") +1){
                            VBox gen = new VBox();
                            gen.getChildren().add(new Label("Generation: " + jobj.get("generation").toString()));
                            gen.setSpacing(10);
                            for (int i = 0; i < indis.size(); ++i){
                                gen.getChildren().add(new Permutation((JSONObject)indis.get(i)));
                            }
                            generations.getChildren().add(gen);
                        }else{
                            for (int i = 0; i < indis.size(); ++i){
                                ((Group)generations.getChildren().get(i)).getChildren().add(new Permutation((JSONObject)indis.get(i)));
                            }
                        }
                    }else if(jobj.containsKey("best")){

                    }
                    break;
                case "change":
                    //configure(jobj);
            }
            return;
        }
    }
}
